diff -ru pdns-recursor-4.0.8.orig/syncres.cc pdns-recursor-4.0.8/syncres.cc
--- pdns-recursor-4.0.8.orig/syncres.cc	2017-12-11 11:38:52.000000000 +0100
+++ pdns-recursor-4.0.8/syncres.cc	2018-10-10 17:07:47.091422717 +0200
@@ -124,6 +124,8 @@
 /** everything begins here - this is the entry point just after receiving a packet */
 int SyncRes::beginResolve(const DNSName &qname, const QType &qtype, uint16_t qclass, vector<DNSRecord>&ret)
 {
+  /* rfc6895 section 3.1 + RRSIG and NSEC3 */
+  static const std::set<uint16_t> metaTypes = { QType::AXFR, QType::IXFR, QType::RRSIG, QType::NSEC3, QType::OPT, QType::TSIG, QType::TKEY, QType::MAILA, QType::MAILB };
   s_queries++;
   d_wasVariable=false;
   d_wasOutOfBand=false;
@@ -172,6 +174,10 @@
     return 0;
   }
 
+  if (metaTypes.count(qtype.getCode())) {
+    return -1;
+  }
+
   if(qclass==QClass::ANY)
     qclass=QClass::IN;
   else if(qclass!=QClass::IN)
@@ -390,7 +396,7 @@
       return ret;
     }
     else if(mode==EDNSStatus::UNKNOWN || mode==EDNSStatus::EDNSOK || mode == EDNSStatus::EDNSIGNORANT ) {
-      if(res->d_rcode == RCode::FormErr || res->d_rcode == RCode::NotImp)  {
+      if(!res->d_haveEDNS && (res->d_rcode == RCode::FormErr || res->d_rcode == RCode::NotImp)) {
 	//	cerr<<"Downgrading to NOEDNS because of "<<RCode::to_s(res->d_rcode)<<" for query to "<<ip.toString()<<" for '"<<domain<<"'"<<endl;
         mode = EDNSStatus::NOEDNS;
         continue;
